<?php
/**
 * @package Sauvegarde
 * @version 1.0
 */
 
/*
Plugin Name: 	ND WP Backup
Plugin URI: 	https://www.networkdigital.fr/
Description: 	Ce plugin permet la sauvegarde de votre site WordPress (PHP et tables SQL) sur un serveur FTP distant avec une récurence régulière
Version: 		1.0.0
Author: 		Patrick JONIEC (Network Digital)
License: 		GPLv2 or later
Text Domain:	sauvegarde
*/

/*

THE LIB DIRECTORY IS NOT A FREE SOFTWARE
The programs included in these directory ar not free and can only be 
used for one Web Site
If you you want to use it for many website, you must buy one licence 
for each website.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
If you find Bugs or problems, you can send us bug details with
our contact form on www.networkdigital.fr
if you have any problem for using it, please contact us.

*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Copyright 2020 Network Digital - Patrick JONIEC
*/


// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

// load_plugin_textdomain( string $domain, string|false $deprecated = false, string|false $plugin_rel_path = false )
load_plugin_textdomain("sauvegarde");

/**
**
** récupérer les fonctions
**
*/

define('NDWPBACKUP_BASEDIR',__DIR__);
require_once NDWPBACKUP_BASEDIR . '/function.php';
require_once NDWPBACKUP_BASEDIR . '/admin/sauvegarde_setting.php';
require_once NDWPBACKUP_BASEDIR . '/admin/sauvegarde_execute.php';

/**
**
** ajouter le menu dans la section administration
**
*/
add_action( 'admin_init', 'ND_WP_Backup_add_page_setting' ); // fonction dans le fichier sauvegarde_setting.php
add_action( 'admin_menu', 'ND_WP_Backup_add_menu_admin');	

function ND_WP_Backup_add_menu_admin() {
	//
	// add_menu_page( string $page_title, string $menu_title, string $capability, string $menu_slug, callable $function = '', string $icon_url = '', int $position = null )
	// add_submenu_page( string $parent_slug, string $page_title, string $menu_title, string $capability, string $menu_slug, callable $function = '', int $position = null )
	//
	// exemple
	//
	// add_menu_page('My Custom Page', 'My Custom Page', 'manage_options', 'my-top-level-slug');
	// add_submenu_page( 'my-top-level-slug', 'My Custom Page', 'My Custom Page', 'manage_options', 'my-top-level-slug');
	// add_submenu_page( 'my-top-level-slug', 'My Custom Submenu Page', 'My Custom Submenu Page', 'manage_options', 'my-secondary-slug');
	
	// add_menu_page(__("ND Sauvegarde - Paramètres","sauvegarde"),__('ND Sauvegarde','sauvegarde'),'manage_options','Sauvegarde_by_NetworkDigital_fr','ND_WP_Backup_Page_Settings');
	// add_submenu_page('Sauvegarde_by_NetworkDigital_fr',__("","sauvegarde"),__('Parametres','sauvegarde'),'manage_options','Sauvegarde_by_NetworkDigital_fr_setting','ND_WP_Backup_Page_Settings');
	// add_submenu_page('Sauvegarde_by_NetworkDigital_fr',__("ND Sauvegarde - Sauvegarder","sauvegarde"),__('Sauvegarder','sauvegarde'),'export','Sauvegarde_by_NetworkDigital_fr_execute','ND_WP_Backup_Page_Execute');
		
	// Menu setting
	 
	if(current_user_can( 'activate_plugins' ))
		add_options_page(__("ND Sauvegarde","sauvegarde"),__('ND sauvegardes','sauvegarde'),'manage_options','Sauvegarde_by_NetworkDigital_fr_setting','ND_WP_Backup_Page_Settings');
	//add_options_page(__("ND Sauvegarde","sauvegarde"),__('ND RAZ sauvegardes','sauvegarde'),'manage_options','Sauvegarde_by_NetworkDigital_fr_RAZ','ND_WP_Backup_setting_raz');
	// Menu d'exécution
	if(current_user_can( 'activate_plugins' )) {
		add_management_page(__("Sauvegarde","sauvegarde"),__('ND sauvegardes','sauvegarde'),'export','Sauvegarde_by_NetworkDigital_fr_execute','ND_WP_Backup_Page_Execute');
		if(file_exists(NDWPBACKUP_BASEDIR . '/lib/CronCreation.php'))
			add_management_page(__("Sauvegarde","sauvegarde"),__('ND Cron Job','sauvegarde'),'export','Sauvegarde_by_NetworkDigital_fr_execute_Cron','ND_WP_Backup_Cron_execute');
	}		
}

/**
**
** Activation du plugin
**
*/
function ND_WP_Backup_activate(){
	// si on n'est pas en admin alors sortir
	if (!current_user_can('manage_options')) die("Vous n'etes pas autorisé à activer le plugin");	
	// Verifier et initialiser les parametres du pluggin
	// Vérifier si les options de sauvegarde existent
	if(!get_option('Sauvegarde_by_NetworkDigital_fr_setting')) {
		// sinon les créer
		ND_WP_Backup_setting_raz();
	}
}
register_activation_hook(__FILE__,'ND_WP_Backup_activate');

function ND_WP_Backup_setting_raz() {
	// vérifier si l'utilisateur dispose des droits
	if(!current_user_can('manage_options')) die("Vous n'êtes pas autorisé à réaliser l'initialisation");

	// Vérifier si des anciennes données sont à supprimer
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
	// Get real path for our folder
	if (!$options) {
		if ($options['nom_dir']!='') {
			$dir_backup = ABSPATH . $options['nom_dir'] . '/';
			if(file_exists($dir_backup)) {
				if ($options['nom_zip']!='') ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_zip'],false);
				if ($options['nom_sql']!='') ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_sql'],false);
				rmdir($dir_backup);
			}
		}
	}
	
	// récuperer le nom du site et remplacer les espaces par des '_' et retirer les caracteres speciaux
	$nomdomaine=ND_WP_Backup_TraiteNomFichier(get_option('blogname'));
	// pour les noms des fichiers, on ajoute une chaine aléatoire pour éviter le téléchargement par un pirate
	$options=array('nom_dir' =>'Backup_'.ND_WP_Backup_random_chaine(10),
		'nom_zip' => 'SauvePHP_'.$nomdomaine.'_'.ND_WP_Backup_random_chaine(10).'_',
		'nom_sql' => 'SauveSQL_'.$nomdomaine.'_'.ND_WP_Backup_random_chaine(10).'_',
		'nom_nb'=>30,
		'ftp_transfert'=>false,
		'ftp_adresse'=>'',
		'ftp_port'=>'21',
		'ftp_user'=>'anonymous',
		'ftp_password'=>'anonymous',
		'ftp_repertoire'=>'',
		'cron_actif'=>false,
		'cron_nbjour'=>3,
		'cron_heure'=>strtotime("02:00"),
		'cron_mail'=>'',
		'cron_last'=>time(),
		'cron_next'=>time()+3*24*60*60);
	// vérifier si le repertoire existe
	// Get real path for our folder
	$rootPath = ABSPATH;
	if (substr($rootPath, -1) !="/") {$rootPath=$rootPath."/";} 
	$dir_backup = $rootPath . $options['nom_dir'];
	if (substr($dir_backup, -1) !="/") {$dir_backup=$dir_backup."/";} 

	// vérifier que le répertoire existe
	if (file_exists($dir_backup)){
		// vérifier que le repertoire est accessible en écriture
		if(!is_writable($dir_backup)) { 
			add_settings_error('Sauvegarde_by_NetworkDigital_fr_setting', 'invalid-setting',sprintf(__("Le répertoire %s n'est pas accessible en écriture","sauvegarde")."<br>",$dir_backup));
		}
	} else {
		// créer le repertoire
		if (!mkdir($dir_backup)) { 
			add_settings_error('Sauvegarde_by_NetworkDigital_fr_setting', 'invalid-setting',sprintf(__("Impossible de créer le répertoire %s","sauvegarde")."<br>",$dir_backup));
		} else {
			add_settings_error('Sauvegarde_by_NetworkDigital_fr_setting', 'invalid-setting',sprintf(__("Le répertoire de sauvegarde %s a été créé.","sauvegarde")."<br>",$dir_backup),"success");
		}
	}
	// créer un fichier index.php dans le repertoire de sauvegarde
	if (!file_exists($dir_backup."index.php")) {
		$index = fopen($dir_backup."index.php", "wb");
		fwrite($index,"<?php \n // Silence is golden.\n");
		fclose($index);
	}
	
	// update_option( string $option, mixed $value, string|bool $autoload = null )
	update_option('Sauvegarde_by_NetworkDigital_fr_setting',$options);
	
	// _e("Les parametres ont été réinitialisés","sauvegarde");
}

/**
**
** Desactivation du plugin
**
*/
function ND_WP_Backup_deactivate() {
	// si on n'est pas en admin alors sortir
	if (!is_admin()) die("Cette action est utilisable uniquement dans le menu administrateur");

	// Supprimer les anciennes sauvegardes
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
	// Get real path for our folder
	if ($options['nom_dir']!='') {
		$dir_backup = ABSPATH . $options['nom_dir'] . '/';
		if ($options['nom_zip']!='') ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_zip'],false);
		if ($options['nom_sql']!='') ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_sql'],false);
	}
	
	// Supprimer les taches programmées si elles existent
	if (file_exists(NDWPBACKUP_BASEDIR . '/lib/CronRemove.php'))
		include NDWPBACKUP_BASEDIR . '/lib/CronRemove.php';
}
register_deactivation_hook(__FILE__,'ND_WP_Backup_deactivate');


/**
**
** Désinstallation du plugin
**
*/
function ND_WP_Backup_uninstall() {
	// si on n'est pas en admin alors sortir
	if (!is_admin()) die("Cette action est utilisable uniquement dans le menu administrateur");

	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
	// supprimer les fichiers de sauvegarde
	// Get real path for our folder
	if ($options['nom_dir']!='') {
		$dir_backup = ABSPATH . $options['nom_dir'] . '/';
		if ($options['nom_zip']!='') ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_zip'],false);
		if ($options['nom_sql']!='') ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_sql'],false);
		rmdir($dir_backup);
	}	
	// Supprimer les parametres de sauvegarde
	remove_option('Sauvegarde_by_NetworkDigital_fr_setting');

}
register_uninstall_hook(__FILE__,'ND_WP_Backup_uninstall');

