<?php

// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

function ND_WP_Backup_Page_Execute() {
	// vérifier que l'utilisateur est autorisé à paramétrer le plugin
	if(!current_user_can('export')) die("Vous n'êtes pas autorisé à exporter le site");
	
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );

	if(!isset($_POST['action'])) {
		echo '<div class="wrap">';
		echo '<h1>'.esc_html(get_admin_page_title()).'</h1>';
		
		// Afficher le message d'achat du plugin
		include NDWPBACKUP_BASEDIR . '/MessageHA.php';
		
		// Afficher les options de la sauvegarde et le bouton 'démarrer la sauvegarde'
		echo '<br>';
		echo '<h2>'.__('Confirmez la réalisation de la sauvegarde avec les paramètres suivants :','sauvegarde').'</h2>';
		// echo var_dump( $_POST);
		echo "<br>";
		echo __("Répertoire = ","sauvegarde").$options['nom_dir']."<br>";
		echo __("Fichier ZIP pour le PHP = ","sauvegarde").$options['nom_zip']."<br>";
		echo __("Fichier SQL pour la Base = ","sauvegarde").$options['nom_sql']."<br><br>";
		if ($options['ftp_transfert']) {
			echo __("Les fichiers seront ensuite transférés sur : ","sauvegarde").$options['ftp_adresse'].":".$options['ftp_port']."<br>";
			echo __("Dans le répertoire : ","sauvegarde").$options['ftp_repertoire']."<br>";
			}
		echo "<form action='tools.php?page=Sauvegarde_by_NetworkDigital_fr_execute&action=demarrer' method='POST'>";
		echo "<input type='text' name='page' value='Sauvegarde_by_NetworkDigital_fr_execute' hidden>";
		echo "<input type='text' name='action' value='executer' hidden>";
		echo "<br><br>";
		echo "<input type='submit' name='submit' id='submit' class='button button-primary' value='".__('Démarrer la sauvegarde','sauvegarde')."' ></p>";
		echo "</form></div>";
		exit;
	}
	
	if ($_POST['action']=="executer") {
		echo '<div class="wrap">';
		echo '<h1>'.esc_html(get_admin_page_title()).'</h1>';
		echo '<br>';
		
		// supprimer les anciens fichiers de sauvegarde
		// Get real path for our folder
		if ($options['nom_dir'] !='') {
			echo __('Suppression des anciens fichiers de sauvegarde','sauvegarde')."<br>";
			$dir_backup = ABSPATH . $options['nom_dir'] . '/';
			echo $dir_backup . " -> " . $options['nom_zip'] . "<br>";
			echo $dir_backup . " -> " . $options['nom_sql'] . "<br>";
			ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_zip'],true);
			ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_sql'],true);
			echo __('Fin de suppression des anciens fichiers de sauvegarde','sauvegarde')."<br><br>";
		}
		echo __("Fichier ZIP pour le PHP = ","sauvegarde").$options['nom_zip']."<br>";
		echo __("Fichier SQL pour la Base = ","sauvegarde").$options['nom_sql']."<br><br>";
		if ($options['ftp_transfert']) {
			echo __("Les fichiers seront ensuite transférés sur : ","sauvegarde").$options['ftp_adresse'].":".$options['ftp_port']."<br>";
			echo __("Dans le répertoire : ","sauvegarde").$options['ftp_repertoire']."<br>";
			}
		wp_ob_end_flush_all();	
		$fichiers=ND_WP_Backup_Execute();			

		// Afficher un formulaire pour la suite du traitement
		if ($options['ftp_transfert'] && file_exists(NDWPBACKUP_BASEDIR . '/lib/TransfertExecute.php')) {
			echo "<form action='tools.php?page=Sauvegarde_by_NetworkDigital_fr_execute&action=demarrer' method='POST'>";
			echo "<input type='text' name='page' value='Sauvegarde_by_NetworkDigital_fr_execute' hidden>";
			echo "<input type='text' name='action' value='transferer' hidden>";
			echo "<input type='text' name='Nom_PHP' value='".$fichiers['Nom_PHP']."' hidden>";
			echo "<input type='text' name='Nom_SQL' value='".$fichiers['Nom_SQL']."' hidden>";
			echo "<br><br>";
			echo "<input type='submit' name='submit' id='submit' class='button button-primary' value='".__('Démarrer le transfert','sauvegarde')."' ></p>";
			echo "</form></div>";
			exit;
		} else {
			_e("Fin de traitement","sauvegarde");
			echo "<br>";
			include NDWPBACKUP_BASEDIR . '/MessageHA.php';
			exit;
		}
	}
	
	if(file_exists(NDWPBACKUP_BASEDIR . '/lib/TransfertExecute.php')) {
		include NDWPBACKUP_BASEDIR . '/lib/TransfertExecute.php';
		echo "<h2>". __("Fin de traitement.","sauvegarde")."</h2>";
	}	
}

function ND_WP_Backup_Execute() {
	// récupérer les parametres
	$options=get_option('Sauvegarde_by_NetworkDigital_fr_setting');
	
	// vérifier que le repertoire existe sinon le créer
	echo __("Vérification du répertoire = ","sauvegarde"). ABSPATH .$options['nom_dir']."<br>";
	if(!file_exists (ABSPATH . $options['nom_dir'])) {
		echo __("Le répertoire n'existe pas","sauvegarde")."<br>";
		echo __("Création","sauvegarde")."<br>";
		mkdir(ABSPATH . $options['nom_dir']);
		if(!file_exists (ABSPATH . $options['nom_dir'])) die("Impossible de créer le dossier de sauvegarde");
	} else {
		echo __("Le répertoire existe","sauvegarde")."<br>";
		}
	echo "<h1>".__("Début de la sauvegarde","sauvegarde")."</h1><br>";
	wp_ob_end_flush_all();	
	
	// Faire la sauvegarde de la base de donnée
	echo __("Sauvegarde de la base de donnée","sauvegarde")."<br>";
	// echo "ND_WP_Backup_Sauve_BD(".DB_NAME.",".DB_USER.",".DB_PASSWORD.",".DB_HOST.",".ABSPATH . $options['nom_dir'].'/'.$options['nom_sql'].",'',true)<br>";
	// ND_WP_Backup_Sauve_BD($name,$user,$pass,$host,$dir_backup,$salt,$affiche)
	$Nom_SQL=$options['nom_sql'].ND_WP_Backup_Sauve_BD( DB_NAME , DB_USER , DB_PASSWORD , DB_HOST , ABSPATH . $options['nom_dir']."/".$options['nom_sql'], '', true);
	wp_ob_end_flush_all();	

	// Faire la sauvegarde du PHP
	// ND_WP_Backup_Sauve_WordPress($repert,$affichage)
	$Nom_PHP=ND_WP_Backup_Sauve_WordPress($options['nom_dir'], $options['nom_zip'], true);
	wp_ob_end_flush_all();

	include NDWPBACKUP_BASEDIR . '/MessageHA.php';

	// Mettre à jour la date de la dernière sauvegarde
	$options['cron_last']=time();
	update_option('Sauvegarde_by_NetworkDigital_fr_setting',$options);
	
	// afficher les liens de téléchargement des sauvegardes
	echo "<br><H1>Vous pouvez télécharger les fichiers en cliquant sur ces liens :</h1><br>";
	echo "<h2><a href='". get_site_url(). '/'. $options['nom_dir'] . '/' . $Nom_PHP ."'>".$Nom_PHP."</a></h2><br>";
	echo "<h2><a href='". get_site_url(). '/'. $options['nom_dir'] . '/' . $Nom_SQL ."'>".$Nom_SQL."</a></h2><br>";;

	$Valeur=array('Nom_PHP' => $Nom_PHP, 'Nom_SQL' => $Nom_SQL);
	return $Valeur;
}

