<?php

// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

function ND_WP_Backup_Page_Settings() {
	// vérifier que l'utilisateur est autorisé à paramétrer le plugin
	if(!current_user_can('manage_options')) die("Vous n'êtes pas autorisé à accéder aux options");
	
	?>
	<div class="wrap">
	<h1><?php echo esc_html(get_admin_page_title()); ?></h1>
	<?php include NDWPBACKUP_BASEDIR . '/MessageHA.php'; ?>
	
	<form action="options.php" method="POST">
	<?php
		// output security fields for the registering setting "sauvegarde_options"
		settings_fields('Sauvegarde_by_NetworkDigital_fr_setting');
		// output setting sections and their fields
		// sections are registered for "sauvegarde"
		// each field is registered to a specific section
		do_settings_sections('Sauvegarde_by_NetworkDigital_fr_setting_page');
		// bouton "Save setting
		submit_button(__('Enregistrer les paramètres','sauvegarde'));
	?>
	</form>	
	</div>
<?php
	$dirjavascript=substr(NDWPBACKUP_BASEDIR,strlen(ABSPATH)-1);
	//echo NDWPBACKUP_BASEDIR . "<br>" . ABSPATH . "<br>" . $dirjavascript ;
	
	if (file_exists(NDWPBACKUP_BASEDIR . '/lib/js/cron.js') && file_exists(NDWPBACKUP_BASEDIR . '/lib/js/transfert.js')) {
		wp_enqueue_script('ND_WP_Backup_javascript_admin',$dirjavascript . '/lib/js/admin.js');
	} elseif (file_exists(NDWPBACKUP_BASEDIR . '/lib/js/cron.js')) {
		wp_enqueue_script('ND_WP_Backup_javascript_cron',$dirjavascript . '/lib/js/cron.js');
	} elseif (file_exists(NDWPBACKUP_BASEDIR . '/lib/js/transfert.js')) {
		wp_enqueue_script('ND_WP_Backup_javascript_transfert',$dirjavascript . '/lib/js/transfert.js');
	}
	
} 
// Fin de ND_WP_Backup_Page_Settings

function ND_WP_Backup_add_page_setting(){
	// register_setting( string $option_group, string $option_name, array $args = array() )
	// add_settings_section( string $id, string $title, callable $callback, string $page )
	// add_settings_field( string $id, string $title, callable $callback, string $page, string $section = 'default', array $args = array() )
	register_setting( 'Sauvegarde_by_NetworkDigital_fr_setting', 'Sauvegarde_by_NetworkDigital_fr_setting', 'ND_WP_Backup_Settings_verif' );
	//register_setting( 'Sauvegarde_by_NetworkDigital_fr_setting', 'Sauvegarde_by_NetworkDigital_fr_setting');
	add_settings_section("Sauvegarde_by_NetworkDigital_fr_fichier",__("Parametres de Sauvegarde","sauvegarde"),"ND_WP_Backup_sai_setting_fichier_text",'Sauvegarde_by_NetworkDigital_fr_setting_page');
		add_settings_field( 'sauvegarde_setting_nom_dir', 'Nom du répertoire', 'ND_WP_Backup_sai_nomdir', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_fichier" );
		add_settings_field( 'sauvegarde_setting_nom_zip', 'Nom du fichier pour le programme', 'ND_WP_Backup_sai_nomzip', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_fichier" );
		add_settings_field( 'sauvegarde_setting_nom_sql', 'Nom du fichier pour la base', 'ND_WP_Backup_sai_nomsql', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_fichier" );
	
	// Setting pour le transfert ftp
	add_settings_section("Sauvegarde_by_NetworkDigital_fr_ftp",__("Parametres de transfert FTP","sauvegarde"),"ND_WP_Backup_sai_setting_ftp_text",'Sauvegarde_by_NetworkDigital_fr_setting_page');
		add_settings_field( 'sauvegarde_setting_transfertftp', 'Activer le transfert', 'ND_WP_Backup_sai_transfertftp', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_ftp" );
		add_settings_field( 'sauvegarde_setting_adresseftp', 'Adresse du serveur ftp', 'ND_WP_Backup_sai_adresseftp', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_ftp" );
		add_settings_field( 'sauvegarde_setting_portftp', 'Port du serveur ftp', 'ND_WP_Backup_sai_portftp', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_ftp" );
		add_settings_field( 'sauvegarde_setting_user', 'Nom d\'utilisateur ftp', 'ND_WP_Backup_sai_user', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_ftp" );
		add_settings_field( 'sauvegarde_setting_pwd', 'Mot de passe ftp', 'ND_WP_Backup_sai_password', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_ftp" );
		add_settings_field( 'sauvegarde_setting_repertftp', 'Répertoire destination du transfert', 'ND_WP_Backup_sai_repertftp', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_ftp" );
		add_settings_field( 'sauvegarde_setting_nom_nb', 'Nombre de jours de sauvegarde conservés', 'ND_WP_Backup_sai_nomnb', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_ftp" );
	
	// Setting pour le cron
	add_settings_section('Sauvegarde_by_NetworkDigital_fr_cron',__("Parametres de planification","sauvegarde"),"ND_WP_Backup_sai_setting_cron_text",'Sauvegarde_by_NetworkDigital_fr_setting_page');
		add_settings_field( 'sauvegarde_setting_cronactif', 'Planifier la sauvegarde automatique', 'ND_WP_Backup_sai_cron', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_cron" );
		add_settings_field( 'sauvegarde_setting_nbjour', 'Nombre de jour entre chaque sauvegarde', 'ND_WP_Backup_sai_nbjour', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_cron" );
		add_settings_field( 'sauvegarde_setting_heure', 'Heure de sauvegarde', 'ND_WP_Backup_sai_heure', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_cron" );
		add_settings_field( 'sauvegarde_setting_mail', 'Adresse mail à avertir en fin', 'ND_WP_Backup_sai_mail', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_cron" );
		add_settings_field( 'sauvegarde_setting_derniere', 'Date de la dernière sauvegarde', 'ND_WP_Backup_sai_last', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_cron" );
		add_settings_field( 'sauvegarde_setting_prochaine', 'Date de la prochaine sauvegarde', 'ND_WP_Backup_sai_next', 'Sauvegarde_by_NetworkDigital_fr_setting_page', "Sauvegarde_by_NetworkDigital_fr_cron" );
}

/**
**
** Fonctions de création des champs de saisie
**
**/
// Section repertoire et noms de fichiers *************************
function ND_WP_Backup_sai_setting_fichier_text() {
	_e("Les noms de répertoire et fichiers de sauvegarde sont calculés aléatoirement pour éviter les risques de récupération des fichiers par un pirate\n","sauvegarde");
	}
function ND_WP_Backup_sai_nomdir () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_nom_dir' name='Sauvegarde_by_NetworkDigital_fr_setting[nom_dir]' type='text' value='".esc_attr( $options['nom_dir'] )."' readonly size='25' />";
}
function ND_WP_Backup_sai_nomzip () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_nom_zip' name='Sauvegarde_by_NetworkDigital_fr_setting[nom_zip]' type='text' value='".esc_attr( $options['nom_zip'] )."' readonly size='40' />";
}
function ND_WP_Backup_sai_nomsql () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_nom_sql' name='Sauvegarde_by_NetworkDigital_fr_setting[nom_sql]' type='text' value='".esc_attr( $options['nom_sql'] )."' readonly size='40' />";
}

// section parametres FTP ******************************************
function ND_WP_Backup_sai_setting_ftp_text() {
	_e("Les parametres ci-dessous permettent de réaliser le transfert des sauvegardes vers un serveut FTP externe\n","sauvegarde");
	echo "<br>";
	_e("Le répertoire à saisir correspond au repertoire de destination sur le serveur FTP à partir de la ravine de connection\n","sauvegarde");
	echo "<br>";
	}
function ND_WP_Backup_sai_transfertftp () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_transfertftp' name='Sauvegarde_by_NetworkDigital_fr_setting[ftp_transfert]' type='checkbox' ";
	if (file_exists(NDWPBACKUP_BASEDIR . '/lib/TransfertExecute.php')) {
		if( $options['ftp_transfert'] ) echo 'checked />';
	} else {
		echo 'disabled />';
		echo "<br>";
		_e("Pour activer cette option, vous pouvez visiter notre site internet","sauvegarde");
		echo "<br><a href='https://www.networkdigital.fr/portfolio-view/plugin-de-sauvegarde-pour-site-internet-sous-wordpress/'>www.networkdigital.fr</a>";
	}
}
function ND_WP_Backup_sai_adresseftp () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_adresseftp' name='Sauvegarde_by_NetworkDigital_fr_setting[ftp_adresse]' type='text' value='".esc_attr( $options['ftp_adresse'] )."' size='40' ";
	if( ! $options['ftp_transfert'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_portftp () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_portftp' name='Sauvegarde_by_NetworkDigital_fr_setting[ftp_port]' type='numebr' value='". $options['ftp_port'] ."' size='5' ";
	if( ! $options['ftp_transfert'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_user () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_user' name='Sauvegarde_by_NetworkDigital_fr_setting[ftp_user]' type='text' value='".esc_attr( $options['ftp_user'] )."' size='30' ";
	if( ! $options['ftp_transfert'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_password () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_pwd' name='Sauvegarde_by_NetworkDigital_fr_setting[ftp_password]' type='text' value='".str_pad('',strlen($options['ftp_password']),"*")."' size='20' ";
	if( ! $options['ftp_transfert'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_repertftp () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_repertftp' name='Sauvegarde_by_NetworkDigital_fr_setting[ftp_repertoire]' type='text' value='".esc_attr( $options['ftp_repertoire'] )."' size='50' ";
	if( ! $options['ftp_transfert'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_nomnb () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_nom_nb' name='Sauvegarde_by_NetworkDigital_fr_setting[nom_nb]' type='number' value='". $options['nom_nb'] ."' size='5'";
	if( ! $options['ftp_transfert'] ) echo 'readonly';
	echo " />";
}

// section tache planifiée ********************************************
function ND_WP_Backup_sai_setting_cron_text() {
	_e("Les parametres ci-dessous permettent de réaliser les sauvegardes (et transfert si parametré) de manière automatique\n","sauvegarde");
	echo "<br>";
	_e("Les sauvegardes sont réalisées selon la fréquence programmée\n","sauvegarde");
	echo "<br>";
	_e("Si l'adresse mail est renseignée, un message sera envoyé lorsque la sauvegarde aura été réalisée\n");
	echo "<br>";
	}
function ND_WP_Backup_sai_cron () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_cronactif' name='Sauvegarde_by_NetworkDigital_fr_setting[cron_actif]' type='checkbox' ";
	if(file_exists(NDWPBACKUP_BASEDIR . '/lib/CronVerif.php')) {
		if( $options['cron_actif'] ) echo 'checked />';
	} else {
		echo 'disabled />';
		echo "<br>";
		_e("Pour activer cette option, vous pouvez visiter notre site internet","sauvegarde");
		echo "<br><a href='https://www.networkdigital.fr/portfolio-view/plugin-de-sauvegarde-pour-site-internet-sous-wordpress/'>www.networkdigital.fr</a>";
	}
}
function ND_WP_Backup_sai_nbjour () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_nbjour' name='Sauvegarde_by_NetworkDigital_fr_setting[cron_nbjour]' type='number' value='". $options['cron_nbjour']."' size='5' ";
	if( ! $options['cron_actif'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_heure () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_heure' name='Sauvegarde_by_NetworkDigital_fr_setting[cron_heure]' type='time' value='".date('H:i', $options['cron_heure'] )."' size='10' ";
	if( ! $options['cron_actif'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_mail () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_mail' name='Sauvegarde_by_NetworkDigital_fr_setting[cron_mail]' type='text' value='".esc_attr( $options['cron_mail'] )."' size='40' ";
	if( ! $options['cron_actif'] ) echo 'readonly';
	echo " />";
}
function ND_WP_Backup_sai_last () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_derniere' name='Sauvegarde_by_NetworkDigital_fr_setting[cron_last]' type='text' value='".date('Y-m-d H:i:s',$options['cron_last'])."' size='20' readonly />&nbsp".date('l',esc_attr( $options['cron_last'] ))."<br>";
	echo __("La date est affichée à l'envers, au format aaaa-mm-dd hh:nn:ss","sauvegarde");
}
function ND_WP_Backup_sai_next () {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
    echo "<input id='sauvegarde_setting_prochaine' name='Sauvegarde_by_NetworkDigital_fr_setting[cron_next]' type='date' value='".date('Y-m-d',$options['cron_next'])."' size='12' ";
	if( ! $options['cron_actif'] ) echo 'readonly';
	echo " />&nbsp".date('l',esc_attr( $options['cron_next'] )) . "<br>";
	// echo __("La date est saisie à l'envers, au format aaaa-mm-dd","sauvegarde");
}

/**
**
** Vérification des saisies
**
**/
function ND_WP_Backup_Settings_verif($saisies) {
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );

	$libelle=array('nom_dir', 'nom_zip', 'nom_sql', 'nom_nb', 'ftp_transfert', 'ftp_adresse', 'ftp_port', 'ftp_user', 'ftp_password', 'ftp_repertoire',	'cron_actif', 'cron_nbjour',
		'cron_heure', 'cron_mail', 'cron_last',	'cron_next');
	
	$newsaisies=$saisies;
	$messageOK="";
	$messageErreur="";
	
	// Setting pour le transfert ftp
	if(file_exists(NDWPBACKUP_BASEDIR . '/lib/TransfertVerif.php')) include NDWPBACKUP_BASEDIR . '/lib/TransfertVerif.php';

	// Setting pour le cron
	if(file_exists(NDWPBACKUP_BASEDIR . '/lib/CronVerif.php')) include NDWPBACKUP_BASEDIR . '/lib/CronVerif.php';	

	if ($messageErreur!="") add_settings_error( 'Sauvegarde_by_NetworkDigital_fr_setting', 'invalid-setting',$messageErreur); 
	if ($messageOK!="") add_settings_error( 'Sauvegarde_by_NetworkDigital_fr_setting', 'OK',$messageOK,"success"); 

	return $newsaisies;	
}
