<?php
// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

if(file_exists(NDWPBACKUP_BASEDIR . '/lib/TransfertFTP.php')) 
		include NDWPBACKUP_BASEDIR . '/lib/TransfertFTP.php';
if(file_exists(NDWPBACKUP_BASEDIR . '/lib/CronCreation.php')) 
		include NDWPBACKUP_BASEDIR . '/lib/CronCreation.php';
include NDWPBACKUP_BASEDIR . '/function/DumpMysql.php';
include NDWPBACKUP_BASEDIR . '/function/SauveBD.php';
include NDWPBACKUP_BASEDIR . '/function/SauveWordPress.php';

//
// Effacer les fichiers plus vieux que $jours en local
// 
// Suppression des vieux fichiers de sauvegarde 
// Repert = Repertoire à vérifier
// NbJour = nombre de jours a conserver
// affiche = true si on affiche les suppressions
//
 
function ND_WP_Backup_Delete_Local_File($Repert,$debut,$NbJours,$affiche ) {
	//
	// supprime les fichiers qui commencent par $debut dans le repertoire $repert
	// et plus vieux que $nbjours
	//
	if (file_exists($repert)) {
		$folder = new DirectoryIterator($Repert);
		foreach($folder as $file){ 
			if(($file->isFile()) && (!$file->isDot()) ) {
				if (time() - $file->getMTime() > $NbJours*24*3600 && (substr($file->getFilename(),0,strlen($debut))==$debut) ) {
					if ($affiche) { echo __("Suppression de ","sauvegarde").$file->getPathname()."<br>\n"; }
					unlink($file->getPathname());   
				}
			}
		}
	}
}

function ND_WP_Backup_Delete_All_Local_File($Repert,$debut,$affiche ) {
	//
	// supprime les fichiers qui commencent par $debut dans le repertoire $repert
	//
	if (file_exists($Repert)) {
		$folder = new DirectoryIterator($Repert);
		foreach($folder as $file){ 
			if(($file->isFile()) && (!$file->isDot()) ) {
				if (substr($file->getFilename(),0,strlen($debut))==$debut) {
					if ($affiche) { echo __("Suppression de ","sauvegarde").$file->getPathname()."<br>\n"; }
					unlink($file->getPathname());   
				}
			}
		}
	}
}

/** 
**
** fonction de calcul d'une chaine aléatoire
** utilisable pour un nom de fichier
** $car = taille de la chaine
** retourne la chaine de caractere générée
**/
function ND_WP_Backup_random_chaine($car) {
    $chaine = "";
    $cle = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnpqrstuvwxy0123456789";
    srand((double)microtime()*1000000);
    for($i=0; $i<$car; $i++) {
		$chaine .= $cle[rand()%strlen($cle)];
		}
    return $chaine;
    }
	
/**
**
** fonction qui modifie un nom de fichier pour remplacer les espaces par des '_'
** et retirer les caracteres speciaux : ! , ; / . # *
**
**/
function ND_WP_Backup_TraiteNomFichier($nom){
	$nouveau=strtr($nom,' !$#"/\*.><%:;,?&|@£ç{[]}',
						'--------------------c----');
	$nouveau=strtr($nouveau,'àâäÄÂ','aaaAA');
	$nouveau=strtr($nouveau,'éèêëËÊ','eeeeEE');
	$nouveau=strtr($nouveau,'îïÏÎ','iiII');
	$nouveau=strtr($nouveau,'ôöÔÖ','ooOO');
	$nouveau=strtr($nouveau,'ùüûÜÛ','uuuUU');
	$nouveau=str_replace("'",'',$nouveau);
	return $nouveau;
	}	
?>
