<?php

// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

/*---------------------------------------------------------------*/
/*
    Titre : Dump (sauvegarde) avec PHP d'une base de donnée MySQL                                                        
    URL   : https://phpsources.net/code_s.php?id=612
    Auteur           : miragoo                                                                                            
    Date édition     : 28 Oct 2010                                                                                        
    Date mise à jour : 13 Sept 2019                                                                                      
	Modification     : 06 Aout 2020
	par P. JONIEC / NetworkDigital.fr
	- adaptation à PHP 7 
	- remplacant les fonctions mysql_xxx par mysqli_xxx 
	- adaptation des résultats des fonctions mysql
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié
*/
/*---------------------------------------------------------------*/


/**
**
** serveur = serveur de base de donnée
** login = nom d'utilisateur
** password = mot de passe de la base de donnée
** base = nom de la base de donnée
** NomFichierDump = nom avec chemin complet pour la sauvegarde de la base de donnée
**
**/

function ND_WP_Backup_dump_MySQL($serveur, $login, $password, $base, $NomFichierDump) {
    
	$connexion = mysqli_connect($serveur, $login, $password);
    $db_select = mysqli_select_db($connexion, $base);

    $fichierDump = fopen($NomFichierDump, "wb");
    
	// Entete
    $entete  = "-- ----------------------\n";
    $entete .= "-- dump de la base ".$base." au ".date("d-M-Y")."\n";
    $entete .= "-- ----------------------\n\n\n";
    fwrite($fichierDump, $entete);

	// Structure de la base de donnée<
    $creations = "";
    
	$creations .= "-- -----------------------------\n";
	$creations .= "-- Structure des tables \n";
	$creations .= "-- -----------------------------\n";
    fwrite($fichierDump, $creations);
	
    $listeTables = mysqli_query($connexion,"show tables");
    while($table = mysqli_fetch_array($listeTables)) {
		$listeCreationsTables = mysqli_query($connexion,"show create table ".$table[0]);
		while($creationTable = mysqli_fetch_array($listeCreationsTables)) {
			fwrite($fichierDump, $creationTable[1].";\n\n");
		}
	}

	// données des tables
    $listeTables = mysqli_query($connexion,"show tables");
    while($table = mysqli_fetch_array($listeTables)) {
		$insertions = "\n\n";
		$donnees = mysqli_query($connexion,"SELECT * FROM ".$table[0]);
		$insertions .= "-- -----------------------------\n";
		$insertions .= "-- Contenu de la table ".$table[0]."\n";
		$insertions .= "-- -----------------------------\n";
		while($nuplet = mysqli_fetch_array($donnees)) {
			$insertions .= "INSERT INTO ".$table[0]." VALUES(";
			for($i=0; $i < mysqli_num_fields($donnees); $i++) {
				// ajouter une virgure avant le champ si ce n'est pas le 1er
				if($i != 0) $insertions .=  ", ";
				$info=mysqli_fetch_field_direct ($donnees, $i);
				$type=$info->type;
				if(is_null($nuplet[$i])) {
					$insertions .= "NULL" ;
				} else {
					if($type == 1 || $type == 2 || $type == 3 || $type == 4 || $type == 5 || $type == 8 || $type == 9 || $type == 16 ) {
						$insertions .= addslashes($nuplet[$i]);
					} else {
						// ajouter un guillemet ouvrant avant les textes & datetime
						$insertions .=  "'" . addslashes($nuplet[$i]) . "'";
					}
				}
            }
            $insertions .=  ");\n";
        }
		fwrite($fichierDump, $insertions);
    }
 
	// fermeture des flux
    mysqli_close($connexion);
    fclose($fichierDump);
}
/**
$mysql_data_type_hash = array(
    1=>'tinyint',
    2=>'smallint',
    3=>'int',
    4=>'float',
    5=>'double',
    7=>'timestamp',
    8=>'bigint',
    9=>'mediumint',
    10=>'date',
    11=>'time',
    12=>'datetime',
    13=>'year',
    16=>'bit',
    //252 is currently mapped to all text and blob types (MySQL 5.0.51a)
    253=>'varchar',
    254=>'char',
    246=>'decimal'
);
*/
