<?php

// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );


//
// Sauvegarde en dump zippé de la base de donnee
//
// name = nom de la base
// user = utilisateur pour se connecter
// pass = password pour se connecter
// host = hebergement de la base
// file_backup = nom du fichier de sauvegarde avec le chemin complet de sauvegarde de la base
// affiche =  true pour afficher les messages
// salt = mot de passe pour crypter la base
//

function ND_WP_Backup_Sauve_BD($name,$user,$pass,$host,$file_backup,$salt,$affiche) {

	if ($affiche) { echo __("Ouverture de la base de donnée","sauvegarde")."<br>\n"; }

	// Verifier l'existance de la base
	$base = mysqli_connect($host, $user, $pass);
	if (!$base) { 
		if ($affiche) { echo "<h1>".__("Serveur MySQL non disponible","sauvegarde")."</h1>\n";} 
		if ($affiche) { echo "<h1>".__("Serveur MySQL (" . $host . "," . $user . "," . $pass . ") non disponible","sauvegarde")."</h1>\n";} 
		die; }
	else { 
		if ($affiche) { echo __("Serveur MySQL connecté","sauvegarde")."<br>\n"; }
		}
	$db_select = mysqli_select_db($base,$name);
	if (!$db_select) { 
		if ($affiche) { echo "<h1>".__("Base non disponible","sauvegarde")."</h1>\n"; }
		die; }
	else { 
		if ($affiche) {echo __("Base connectée","sauvegarde")."<br>\n"; }
		}
	mysqli_close ($base);
	
	// Génération du fichier de sauvegarde dans le fichier avec chemin complet $file_backup
	// Calcul du nom de l'archive en ajoutant la date et heure du jour
	$Name_Archive=date("d_n_Y_H_i_s").'.sql';
	
	//if ($salt!='') {
	//	$Name_Archive=$Name_Archive.'.salt';
	//	system ( 'mysqldump --lock-tables=false --host='.$host.' --user='.$user.' --password='.$pass.' --databases '.$name.' | zip | openssl enc -des3 -salt -pass pass:' . $salt . ' > '.$file_backup.$Name_Archive);
	//	}
	//else {
	//	system ( 'mysqldump --lock-tables=false --host='.$host.' --user='.$user.' --password='.$pass.' --databases '.$name.' | zip > '.$file_backup.$Name_Archive);
	//	}

	//ND_WP_Backup_dump_MySQL($serveur, $login, $password, $base, $NomFichierDump)
	ND_WP_Backup_dump_MySQL($host, $user, $pass, $name, $file_backup.$Name_Archive);
	
	// création du zip
	if ($affiche) echo __("Création d'un ZIP pour la base de donnée.","sauvegarde")."<br>\n";
	$zip = new ZipArchive();
	$zip->open($file_backup.$Name_Archive.".zip", ZipArchive::CREATE);
	if (!$zip) { 
		if ($affiche) { 
			echo __("Erreur creation du zip","sauvegarde")."<br>\n"; 
			die;
		}
	}
	$zip->addFile($file_backup.$Name_Archive, $Name_Archive);
	// Zip archive will be created only after closing object
	if ($affiche) echo __("Fermeture du ZIP (enregistrement des fichiers ajoutés).","sauvegarde")."<br>\n";
	flush();
	$zip->close();	
	if ($affiche) echo __("Archive créée","sauvegarde")."<br>\n";
	flush();
	// Suppression du fichier sql
	unlink($file_backup.$Name_Archive);

	$Name_Archive .='.zip';

	if ($affiche) {echo __("dump executé","sauvegarde")."<br>\n";}
	
	return $Name_Archive;
}
