<?php

// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

//
// Sauvegarde des fichiers PHP de WordPress dans un zip
//
// repert = repertoire destination de la sauvegarde (à partir de la racine du site)
// affichage = true si on affiche les messages
//
// Retourne le nom de l'archive créée
//
//	
	
function ND_WP_Backup_Sauve_WordPress($repert,$fichier,$affichage) {
	// Get real path for our folder
	$rootPath = $_SERVER['DOCUMENT_ROOT'];
	if (substr($rootPath, -1) !="/") {$rootPath .= "/";} 
	if ($affichage) {echo __("Racine : ","sauvegarde").$rootPath."<br>\n"; }
	$dir_backup = $rootPath . $repert;
	if (substr($dir_backup, -1) !="/") {$dir_backup .= "/";} 
	if ($affichage) {echo __("Backup : ","sauvegarde").$dir_backup."<br>\n"; }

	// vérifier que le répertoire existe
	if (file_exists($dir_backup)){
		// vérifier que le repertoire est accessible en écriture
		if(!is_writable($dir_backup)) { 
			if ($affichage) { sprintf (__("Le répertoire %s n'est pas accessible en écriture","sauvegarde")."<br>\n",$dir_backup); die; }
		}
	} else {
		// créer le repertoire
		if (!mkdir($dir_backup)) { 
			if ($affichage) sprintf(__("Impossible de créer %s","sauvegarde")."<br>\n",$dir_backup); die; }
		}
	
	$Name_Archive = $fichier .date("d_n_Y_H_i_s").".zip";
	if ($affichage) {sprintf( __("Création de l'archive : %s","sauvegarde").'<br>\n',$Name_Archive);}

	// Initialize archive object
	$zip = new ZipArchive();
	$zip->open($dir_backup.$Name_Archive, ZipArchive::CREATE);
	if (!$zip) { 
		if ($affichage) { echo __("Erreur creation du zip","sauvegarde")."<br>\n"; die; }
		}
	//else { echo "Archive créée ".$Name_Archive); }

	if ($affichage) {
		echo __("Ajout des fichiers de la racine","sauvegarde")."<br>\n";
		flush();
		}
	ND_WP_Backup_ZIP_add_file('',$zip,$rootPath);
	
	if ($affichage) {
		echo __("Ajout des fichiers de contenu","sauvegarde")."<br>\n";
		flush();
		}
	ND_WP_Backup_ZIP_add_folder('wp-content',$zip,$rootPath);
	
	if ($affichage) {
		echo __("Ajout des fichiers de l'administration","sauvegarde")."<br>\n";
		flush();
		}
	ND_WP_Backup_ZIP_add_folder('wp-admin',$zip,$rootPath);
	
	if ($affichage) {
		echo __("Ajout des fichiers de bibliotheque","sauvegarde")."<br>\n";
		flush();
		}
	ND_WP_Backup_ZIP_add_folder('wp-includes',$zip,$rootPath);

	// Zip archive will be created only after closing object
	if ($affichage) echo __("Fermeture du ZIP (enregistrement des fichiers ajoutés).","sauvegarde")."<br>\n";
	flush();
	$nbfichiers=$zip->count();
	$zip->close();
	if ($affichage) echo __("Archive créée","sauvegarde")."<br>\n";
	if ($affichage) echo __("Nombre de fichiers : ","sauvegarde"). $nbfichiers . "<br>\n";
	flush();
	
	return $Name_Archive;
} 

function ND_WP_Backup_ZIP_add_file($repert,$zip,$rootPath) {
	// Ajouter les fichiers d'un répertoire
	$folder = new DirectoryIterator($rootPath.$repert);
	foreach($folder as $file){ 
		// Get real and relative path for current file
		$filePath = $file->getRealPath();
		$relativePath = substr($filePath, strlen($rootPath));
		// Skip '..' directory (risk of error with auth)
		if (strlen($filePath) > strlen($rootPath)) {
			// Skip directories (they would be added automatically with RecursiveIterator)
			if((!$file->isDir())) {
				// echo $filePath . " -> " . $relativePath . '<br>';
				// Add current file to archive
				$zip->addFile($filePath, $relativePath);
				}
			}
		}
	}

function ND_WP_Backup_ZIP_add_folder($repert,$zip,$rootPath) {
	// Ajouter les fichiers d'un dossier et des sous-dossiers
	// Create recursive directory iterator
	/** @var SplFileInfo[] $files */
	$files = new RecursiveIteratorIterator(
		new RecursiveDirectoryIterator($rootPath.$repert),
		RecursiveIteratorIterator::LEAVES_ONLY);

	foreach ($files as $name => $file){
		// Get real and relative path for current file
		$filePath = $file->getRealPath();
		$relativePath = substr($filePath, strlen($rootPath));
		// Skip '..' directory (risk of error with auth)
		if (strlen($filePath) > strlen($rootPath)) {
			// Skip directories (they would be added automatically with RecursiveIterator)
			if (!$file->isDir()) {
				// echo $filePath . " -> " . $relativePath . '<br>';
				// Add current file to archive
				$zip->addFile($filePath, $relativePath);
				//$zip->setEncryptionName($filePath, ZipArchive::EM_AES_256, DB_PASSWORD);
				}
			}
		}
	}
