<?php
// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

// Ajouter le cron au systeme WordPress
add_action('Sauvegarde_by_NetworkDigital_fr_cron_hook','ND_WP_Backup_Cron_execute');

/**
**
** Fonction programmable d'exécution automatique de la sauvegarde
** Fonction appelé par add_action ci-dessus
**
**/
function ND_WP_Backup_Cron_execute(){
		
	// Récupérer les parametres
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
	
	// Si les options sont vides alors quitter
	if ( $options['nom_dir']=='' ||  $options['nom_zip']=='' || $options['nom_sql']=='') {
		ND_WP_Backup_SendMailSauvegarde($options['cron_mail'],__("Erreur de la sauvegarde automatique sur le site ","sauvegarde") . get_option('blogname') ,__("Les parametres sont errones : nom du repertoire ou nom du zip ou nom du sql vides","sauvegarde"));
		die;
	}
	
	// supprimer les anciens fichiers de sauvegarde
	// Get real path for our folder
	$dir_backup = ABSPATH . $options['nom_dir'] . '/';
	ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_zip'],false);
	ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_sql'],false);
	if(!file_exists (ABSPATH . $options['nom_dir']))
		mkdir(ABSPATH . $options['nom_dir']);
	// Faire la sauvegarde du PHP
	// ND_WP_Backup_Sauve_WordPress($repert,$affichage)
	$Nom_PHP=ND_WP_Backup_Sauve_WordPress($options['nom_dir'], $options['nom_zip'], false);
	// Sauvegarde du SQL
	$Nom_SQL=$options['nom_sql'].ND_WP_Backup_Sauve_BD( DB_NAME , DB_USER , DB_PASSWORD , DB_HOST , ABSPATH . $options['nom_dir']."/".$options['nom_sql'], '', false);
	
	// Transfert vers le site FTP
	if ($options['ftp_transfert'] && file_exists( NDWPBACKUP_BASEDIR . '/lib/CronTransfert.php')) {
		include NDWPBACKUP_BASEDIR . '/lib/CronTransfert.php';
	}
	
	// Envoyer le mail de résultat ok
	if ($options['ftp_transfert'] && file_exists( NDWPBACKUP_BASEDIR . '/lib/CronTransfert.php')) {
		// Get real path for our folder
		$dir_backup = ABSPATH . $options['nom_dir'] . '/';
		// Supprimer les sauvegardes si elles ont été transférées en ftp
		ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_zip'],false);
		ND_WP_Backup_Delete_All_Local_File( $dir_backup , $options['nom_sql'],false);
		$sujetmail = __("Sauvegarde ftp reussie de ","sauvegarde") . get_option('blogname');
		$messagemail=__("Votre site internet a ete transfere sur le serveur ftp","sauvegarde") . " \n ";
		$messagemail .= $options['ftp_adresse']." \n";
		$messagemail .= __("Dans le dossier : \n","sauvegarde");
		$messagemail .= $options['ftp_repertoire'] ." \n";
		$messagemail .= __("Journal des taches : \n","sauvegarde");
		$messagemail .= $retour['tache'] ." \n";		
	} else {
		$sujetmail = __("Sauvegarde reussie en local de ","sauvegarde") . get_option('blogname');
		$messagemail = __("Votre site internet a ete sauvegarde en local sur votre site","sauvegarde") . " \n";
		$messagemail .= __("Vous pouvez les telecharger en ouvrant les liens suivants :","sauvegarde") . " \n";
		$messagemail .= get_site_url(). '/'. $options['nom_dir'] . '/' . $Nom_PHP ." \n";
		$messagemail .= get_site_url(). '/'. $options['nom_dir'] . '/' . $Nom_SQL . " \n";
		$messagemail .= __("ATTENTION : Ces liens sont valides uniquement jusqu'a la prochaine sauvegarde !","sauvegarde") . "\n";
	}
	_e("Fin de traitement","sauvegarde");
	
	// Préparation de la programmation suivante
	$options['cron_last'] = time();
	if ($options['cron_next']+$options['cron_heure']<time()) {
		// L'exécution n'a pas été forcée
		// Quelquesoit le moment de l'exécution, on conserve la périodicité d'exécution
		// et on cherche la prochaine sauvegarde qui respectera la périodicité
		$options['cron_next'] += 86400* $options['cron_nbjour'];
		while ($options['cron_next'] < time()) 
			$options['cron_next'] += 86400 * $options['cron_nbjour']; // 24*60*60 = 86400 secondes par jour
	}
		
	// On enregistre les nouveaux parametres pour le cron
	update_option('Sauvegarde_by_NetworkDigital_fr_setting',$options);

	// ajouter la date de la prochaine sauvegarde dans le mail
	$messagemail .= " \n";
	$messagemail .= __("Prochaine sauvegarde programmee pour le (dd/mm/yyyy) = ","sauvegarde") . date("d/m/Y",$options['cron_next']) . " " . date('H:i', $options['cron_heure'] ) . " \n";
	
	// Envoyer le mail
	ND_WP_Backup_SendMailSauvegarde($options['cron_mail'],$sujetmail,$messagemail);

	// On enregistre la prochaine échéance dans le cron
	ND_WP_Backup_Cron_Creation();
		
}

/**
**
** Création de la tache programmée
** - horaire = timestamp de la tache
**
**/
function ND_WP_Backup_Cron_Creation(){
	
	// Si la programmation a déjà été enregistrer, la supprimer avant de la créer
	if ($timestamp = wp_next_scheduled('Sauvegarde_by_NetworkDigital_fr_cron_hook'))
		wp_unschedule_event( $timestamp,'Sauvegarde_by_NetworkDigital_fr_cron_hook');

	// Récupérer les parametres
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
	
	//	Ajouter une nouvelle tache
	// wp_schedule_event( int $timestamp, string $recurrence, string $hook, (optional) array $args = array() )
	// wp_schedule_single_event( int $timestamp, string $hook, (optional) array $args = array() )
	$prochaine=$options['cron_next']+$options['cron_heure'];
	wp_schedule_single_event( $prochaine, 'Sauvegarde_by_NetworkDigital_fr_cron_hook' );
}

/**
**
** Envoie à mail si l'adresse mail de destination est renseignée
**
**/
function ND_WP_Backup_SendMailSauvegarde($to,$sujet,$contenu) {
	// Vérifier que le mail est rempli
	if ($to!='') {
		// vérifier que l'adresse mail est correctement formée
		if(filter_var($to, FILTER_VALIDATE_EMAIL)) {
			wp_mail($to,$sujet,$contenu);
		}
	}
}
