<?php

	// Make sure we don't expose any info if called directly
	if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

	if (!isset($saisies['cron_actif'])) $newsaisies['cron_actif']=false;
	
	// vérifier l'adresse mail
	if($saisies['cron_mail']!='' && $saisies['cron_mail']!=$options['cron_mail']){
		if(!filter_var($saisies['cron_mail'], FILTER_VALIDATE_EMAIL)) {
			$messageErreur .= __("L'adresse mail saisie n'est par correcte.","sauvegarde");
		} else {
			// Envoyer un mail pour vérifier que le destinataire le reçois
			$sujet=__("Test de mail pour la sauvegarde du site ","sauvegarde") . get_option('blogname');
			$contenu = __("Ce mail vous est envoye pour tester la bonne reception des futurs messages qui viendrons de votre site","sauvegarde") ."\n\n";
			$contenu .= "Visitez notre site internet pour plus d'informations : www.networkdigital.fr \n";
			$contenu .= "Vous trouverez toutes les informations pour l'utilisation de ce plugin\n";
			$contenu .= "Merci pour votre achat de ces extensions du plugin\n";
			$contenu .= "Si vous aimez ce plugin, n'hesitez pas a le faire savoir autour de vous\n";
			$contenu .= "Pensez a laisser votre avis sur le magasin WordPress et sur notre site internet\n";
			$contenu .= "-------------------------------------------------------------------------\n";
			$contenu .= "Visit our web site for more informations : www.networkdigital.fr \n";
			$contenu .= "You can find all informations about using this plugin\n";
			$contenu .= "Thank you for purchasing these plugin extensions\n";			
			$contenu .= "If you like this plugin, do not hesitate to let people know about it.\n";
			$contenu .= "Remember to leave your opinion in the WordPress store and in our website\n";
			$contenu .= "\n\n";
			$contenu .= "Patrick JONIEC\n";
			if (wp_mail($saisies['cron_mail'],$sujet,$contenu))
				$messageOK .= __("Un mail vous a été envoyé. vérifiez si vous le recevez, ou vérifiez dans vos spams","sauvegarde") . "<br>";
			else
				$messageErreur .= __("Une erreur s'est produite lors de l'envoi du mail de confirmation","sauvegarde") . "<br>";
		}
	}

	// Verifier la periodicite
	if($newsaisies['cron_nbjour']<1) {
		$messageErreur .= __("La périodicité ne peux pas être inférieure à 1 jour","sauvegarde") . "<br>";
		$newsaisies['cron_nbjour']=$options['cron_nbjour'];
	}
	
	// transformer les dates pour la programmation automatique des sauvegardes
	if(is_numeric($newsaisies['cron_last'])) {
		// Si la date saisie est numérique et proche de l'heure actuelle alors la conserver
		if ($newsaisies['cron_last']<time()-100)
			$newsaisies['cron_last']=$options['cron_last'];
	} else {
		// la date de la dernière sauvegarde réalisée est conservée 
		$newsaisies['cron_last']=$options['cron_last'];
	}
	
	// la date de la prochaine est enregistrée et vérifiée
	// remettre la date du format Y-m-d au format m-d-Y
	if(!is_numeric($newsaisies['cron_next'])) {
		$nouvelledate=substr($newsaisies['cron_next'],5,2)."/".substr($newsaisies['cron_next'],-2,2)."/".substr($newsaisies['cron_next'],0,4);
		$newsaisies['cron_next']=strtotime($nouvelledate);
		if(!$newsaisies['cron_next']) { 
			// Si la date est fausse on conserve l'ancienne et on envoi une erreur
			$messageErreur .= __("La date de la prochaine sauvegarde n'est pas correcte : ","sauvegarde") . $saisies['cron_next'] . "->" .$nouvelledate . "<br>";
			$newsaisies['cron_next']=$options['cron_next'];
		}
	} else {
		if ($options['cron_next'] < time()) 
			$options['cron_next'] = strtotime(date("m/d/Y",time()+86400 * $newsaisies['cron_nbjour'])); // 24*60*60 = 86400 secondes par jour
	}
	
	// convertir l'heure de sauvegarde et time
	// pour avoir juste le timestamp de l'heure, on indique le 1er jour de référence de timestamp (01/01/1970)
	$newsaisies['cron_heure']=strtotime("01/01/1970 ".$saisies['cron_heure']);
	if(!$newsaisies['cron_heure']) {
		if ($saisies['cron_heure']!="0:00" || $saisies['cron_heure']!="0:0" || $saisies['cron_heure']!="00:00" || $saisies['cron_heure']!="00:0") { 
			$newsaisies['cron_heure']=0;
		} else {
			// Si l'heure est fausse on conserve l'ancienne et on envoi une erreur
			$messageErreur .= __("L'horaire de la prochaine sauvegarde n'est par correcte.","sauvegarde") ."<br>";
			$newsaisies['cron_heure']=$options['cron_heure'];
		}
	}	

	// Si la programmation est activée
	if ($newsaisies['cron_actif']) {
		// Vérifier que la date de la prochaine sauvegarde est dans le futur
		if ( $newsaisies['cron_next']+$newsaisies['cron_heure'] < time()) {
			$messageErreur .= __("La date de la prochaine sauvegarde doit être dans le futur.","sauvegarde") ."<br>";
			$newsaisies['cron_next']=$options['cron_next'];
		}
	}
	
	// Si la programmation a déjà été enregistrer, la supprimer avant de la créer
	if ($timestamp = wp_next_scheduled('Sauvegarde_by_NetworkDigital_fr_cron_hook'))
		wp_unschedule_event( $timestamp,'Sauvegarde_by_NetworkDigital_fr_cron_hook');

	// Si la programmation est activée
	if ($newsaisies['cron_actif']) {
		// Créer la tache planifiée et afficher le message
		$prochaine=$newsaisies['cron_next']+$newsaisies['cron_heure'];
		wp_schedule_single_event( $prochaine, 'Sauvegarde_by_NetworkDigital_fr_cron_hook' );
		// $messageOK .= "Tentative de planification de la tache pour le " . date("Y-m-d H:i",$prochaine) ."<br>";
		
		$timestamp = wp_next_scheduled('Sauvegarde_by_NetworkDigital_fr_cron_hook');
		if (!$timestamp) {
			$messageErreur .= __("La tache de sauvegarde n'a pas pu être planifiée pour le ","sauvegarde") . date("Y-m-d H:i",$timestamp) ."<br>";
		} else {
			$messageOK .= __("La tache de sauvegarde a été programmée pour le ","sauvegarde") . date("Y-m-d H:i",$timestamp) ."<br>";
		}
	}
	