<?php
// Make sure we don't expose any info if called directly
if (!defined('ABSPATH')) die( 'Hi there!  I\'m just a plugin, not much I can do when called directly.' );

//
// serveur = adresse IP du serveur
// port = port (généralement 21)
// user = utilisateur de connection
// pass = mot de passe de connection
// Destination : 
//     - tohost pour un transfert vers distant
//     - tolocal pour un téléchagement distant vers local
// remote = chemin d'accès distant
// local = chemin d'accès local
// fichiers = tableau des fichiers à transférer
// affiche : true si le texte est affiché sur la page / false sinon
//
// Retour tableau : 
//    'succes' -> False si erreur de connection ou erreur de transfert
//	  'tache' -> texte des taches réalisées
//  

function ND_WP_Backup_Transfert_FTP($server , $port, $user , $pass , $remote , $local , $destination , $fichiers, $affiche){ 
	
	// Vérifier si les chemins se terminent par / sinon l'ajouter
	$last2=substr($local, -1); 
	if ($last2 !="/") {$local=$local."/";} 
  
	// se connecter au serveur
	if ($affiche) echo "Connection au serveur : ".$server.":".$port."<br>\n";
	wp_ob_end_flush_all();	
	$ftpc=ftp_connect($server,$port); 
	if(!$ftpc) {
		if ($affiche) { echo __("Erreur lors de la connection au serveur","sauvegarde")."<br>\n"; }
		return array('succes' => false,'tache' => __("Erreur lors de la connection au serveur","sauvegarde")."\n");
		die; 
		} 
		
	if ($affiche) echo "Identification sur le serveur ftp : ".$user."<br>\n";
	wp_ob_end_flush_all();	
	$result_login=ftp_login($ftpc, $user, $pass); 
	if (!$result_login){ 
		if ($affiche) { echo __("Nom d'utilisateur ou mot de passe non reconnu","sauvegarde")."<br>\n"; }
		return array('succes' => false,'tache' => __("Nom d'utilisateur ou mot de passe non reconnu","sauvegarde")."\n");
		die; 
		}
		
	if ($affiche) echo sprintf (__("Connecté au serveur %s - utilisateur %s","sauvegarde")."<br>\n",$server,$user);
	$tache = __("Connecté au serveur ","sauvegarde") . $server . __(" utilisateur ","sauvegarde"). $user . " \n";
	wp_ob_end_flush_all();	
  
	ftp_pasv($ftpc,true);
  
	$retour=true; 
	$fic = array_values($fichiers); 
	switch($destination) { 
		case "tohost" : 
			foreach($fic as $nom) {
				if ($affiche) echo "Transfert de ".$local.$nom." vers ".$remote.$nom."<br>\n";
				$tache .= "Transfert de ".$local.$nom." vers ".$remote.$nom."\n";
				flush();
				$put= ftp_put($ftpc, $remote.$nom, $local.$nom, FTP_BINARY); 
				if (!$put) { 
					if ($affiche) { sprintf(__("Le transfert de %s a échoué","sauvegarde")."<br>\n",$nom); }
					$tache .= __("Le transfert a echoue pour : ","sauvegarde") . $nom . "\n";
					$retour=false;
				} 
				else { 
					if ($affiche) { sprintf(__("Transfert de %s vers %s reussi","sauvegarde")."<br>\n",$nom,$remote); }
					$tache .= __("Le transfert a reussi pour : ","sauvegarde") . $nom . "\n";
				} 
			} 
			break; 
  
		case "tolocal" : 
			foreach($fic as $nom) { 
				$get= ftp_get($ftpc, $local.$nom, $remote.$nom, FTP_BINARY); 
				if (!$get) { 
					if ($affiche) { sprintf(__("Le téléchargement de %s a echoue","sauvegarde")."<br>\n",$nom); }
					$tache .= __("Le téléchargement a echoue pour : ") . $remote.$nom . "\n";
					$retour=false;
				} 
				else { 
					if ($affiche) { echo sprintf(__("Téléchargement de %s vers %s réussi","sauvegarde")."<br>\n",$remote.$nom,$local); }
					$tache .= __("Le téléchargement a reussi pour : ") . $remote.$nom . "\n";
				} 
			} 
			break; 
  
		} 
	// Supprimer les fichiers trop anciens du serveur
	$options = get_option( 'Sauvegarde_by_NetworkDigital_fr_setting' );
	$tache .= ND_WP_Backup_Delete_All_Ftp_File($ftpc,$remote,$options['nom_zip'],$options['nom_nb'],$affiche);
	$tache .= ND_WP_Backup_Delete_All_Ftp_File($ftpc,$remote,$options['nom_sql'],$options['nom_nb'],$affiche);
	
	// fermer la connection FTP
	ftp_quit($ftpc); 
	if ($affiche) echo "Déconnecté du serveur<br>";
	if ($affiche) echo "Fin de transfert<br>";
	return array('succes'=>$retour,'tache'=>$tache); 
	}	

//
// Effacer les fichiers plus vieux que $jours sur serveur ftp
// 
// Suppression des vieux fichiers de sauvegarde 
// ftp = connection ftp ouverte
// Repert = Repertoire à vérifier
// NbJour = nombre de jours a conserver
// affiche = true si on affiche les suppressions
//
 
function ND_WP_Backup_Delete_All_Ftp_File($ftpc,$Repert,$debut,$NbJours,$affiche ) {
	//
	// supprime les fichiers qui commencent par $debut dans le repertoire $repert sur un serveur ftp
	//
	$tache='';
	$folder = ftp_mlsd($ftpc,$Repert);
	$DateAvant=date('YndHi',time()-$NbJours*24*3600) . "00";
	if ($affiche) echo sprintf(__("Effacer les fichiers %s avant le %s sur le serveur ftp","sauvegarde"),$debut,$DateAvant) . '<br>';
	$tache .= __("Effacer les fichiers ","sauvegarde") . $debut . __(" avant le ","sauvegarde") . $DateAvant . __(" sur le serveur ftp","sauvegarde") . '\n';
	foreach($folder as $file){ 
		if ($affiche) echo __("Verification de ","sauvegarde") . substr($file['name'],0,strlen($debut)) . " " . $file['name'] . " -> " . $file['type'] . " du " . $file['modify'] . " " . "<br>";
		if($file['type']=="file") {
			if ($file['modify'] < $DateAvant) {
				// echo $file['modify'] . "<" . $DateAvant . "<br>";
				if (substr($file['name'],0,strlen($debut))==$debut) {
					if ($affiche) echo __("Suppression de ","sauvegarde").$file['name']."<br>";
					$tache .= __("Suppression de ","sauvegarde") . $file['name'] . "\n";
					ftp_delete($ftpc,$Repert . $file['name']);
				}
			}
		}
	}
	return $tache;
}